#include "mainwindow.h"
#include "ui_mainwindow.h"
#include "peoplemodel.h"
#include "manymapper.h"

MainWindow::MainWindow(QWidget *parent)
  : QMainWindow(parent)
  , ui(new Ui::MainWindow)
{
  ManyMapper *mm = new ManyMapper(this);
  ui->setupUi(this);

  PeopleModel *pm = new PeopleModel(this);
  ui->listView->setModel(pm);

  mm->setSubmitPolicy(ManyMapper::AutoSubmit);
  mm->setModel(pm);
  connect(ui->listView->selectionModel(), &QItemSelectionModel::selectionChanged, [mm](const QItemSelection& selection){
    mm->setCurrentIndex(selection.first().top());
  });

  mm->addMapping(ui->nameEdit, 0);
  mm->addMapping(ui->cellEnabledCheckBox, 1);
  // map the "user" property of cellEdit to actual value
  mm->addMapping(ui->cellEdit, 2);
  // map the enabled property of cellEdit to whether this value is enabled
  // standard QDataWidgetMapper will override the previous mapping
  // and cell will not have value, but custom ManyMapper fixes this
  mm->addMapping(ui->cellEdit, 1, "enabled");

  mm->toFirst();
}

MainWindow::~MainWindow()
{
  delete ui;
}

