#ifndef MANYMAPPER_H
#define MANYMAPPER_H

#include <QDataWidgetMapper>
#include <QMetaProperty>

class ManyMapper : public QDataWidgetMapper
{
  Q_OBJECT

  struct Mapping {
    QWidget* widget;
    int section;
    QMetaProperty prop;
  };

  QList<Mapping> _widgetList;
  int _currentIndex;

public:
  ManyMapper(QObject *parent = nullptr);
  ~ManyMapper() { _widgetList.clear(); }

  void setModel(QAbstractItemModel *model);
  void addMapping(QWidget *widget, int section, QByteArray propertyName = "");

 public slots:
  void setCurrentIndex(int index) override;  // toFirst(), toLast(), etc.

 private slots:
  void widgetChanged();
};

#endif // MANYMAPPER_H
