#include "peoplemodel.h"

static QVariant peopledata[][3] = {
  {"John Doe", true, "111-111-1111"},
  {"Doe John", false, "222-222-2222"},
  {"John John", true, "333-333-3333"},
  {"Doe Doe", false, "444-444-4444"},
  {"Doe John Doe", true, "555-555-5555"}
};

PeopleModel::PeopleModel(QObject *parent)
  : QAbstractItemModel(parent)
{
}

QVariant PeopleModel::headerData(int section, Qt::Orientation /*orientation*/, int role) const
{
  if (role != Qt::DisplayRole) return QVariant();

  switch (section) {
  case 0: return "Name";
  case 1: return "TextEnabled";
  case 2: return "TextNumber";
  }

  return QVariant();
}

QModelIndex PeopleModel::index(int row, int column, const QModelIndex &/*parent*/) const
{
  return this->createIndex(row, column);
}

QModelIndex PeopleModel::parent(const QModelIndex &/*index*/) const
{
  return QModelIndex();
}

int PeopleModel::rowCount(const QModelIndex &/*parent*/) const
{
  return 5;
}

int PeopleModel::columnCount(const QModelIndex &/*parent*/) const
{
  return 3;
}

QVariant PeopleModel::data(const QModelIndex &index, int role) const
{
  if (role != Qt::DisplayRole && role != Qt::EditRole) return QVariant();

  if (!index.isValid() || index.row() < 0 || index.row() >= 5 || index.column() < 0 || index.column() >= 3)
    return QVariant();

  return peopledata[index.row()][index.column()];
}

bool PeopleModel::setData(const QModelIndex &index, const QVariant &value, int role) {
  if (role != Qt::DisplayRole && role != Qt::EditRole) return false;

  if (!index.isValid() || index.row() < 0 || index.row() >= 5 || index.column() < 0 || index.column() >= 3)
    return false;

  peopledata[index.row()][index.column()] = value;
  emit dataChanged(index,index);
  return true;
}
